// Form1.cpp

#include "stdafx.h"

#include "Form1.h"
#include "WndMessageHolder.h"

using namespace BringUpTest;

// Message handler for primary instance activation

void Form1::WndProc(Message %msg)
{
  if (msg.Msg == WndMessageHolder::GetInstance()->WM_BRINGUP) BringMeUp();
  __super::WndProc(msg);
}

// Handles WM_BRINGUP message

void Form1::BringMeUp()
{
  if (m_bAltInstanceSwitch) {
    // Alternative version - works but unfortunately looks hackish...

    if (WindowState != FormWindowState::Minimized)
      WindowState = FormWindowState::Minimized;
    WindowState = FormWindowState::Normal;
    // Activate();
  } else {
    // "Classic" version according to TheGreatCthulhu's suggestion - unfortunately doesn't
    // really work completely... (see CG forum thread)

    if (WindowState == FormWindowState::Minimized)
      WindowState = FormWindowState::Normal;

    Activate();
  }
}

// Event handler to switch between the two instance switching modes

System::Void Form1::InstanceSwitchModeChanged(System::Object^  sender, System::EventArgs^  e)
{
  if (rbClassic->Checked) m_bAltInstanceSwitch = false;
  else if (rbAlt->Checked) m_bAltInstanceSwitch = true;
  else Diagnostics::Trace::Fail("What the heck... Unexpected outcome of instance switching mode change");
}
