// WndMessageHolder.h

#pragma once

#include <Windows.h>

namespace BringUpTest
{

using namespace System;
using namespace System::Windows::Forms;

public ref class WndMessageHolder
{
public:
  static WndMessageHolder ^GetInstance();

  static Int32 GetLastError_();

  initonly int WM_BRINGUP;

  bool PostMessage_(IntPtr, int, IntPtr, IntPtr);

  // Taken strictly, the following doesn't really belong here...
  // Actually, it isn't even used as of now. It's a remnant from earlier experiments.

  bool SetForegroundWindow_(IWin32Window ^);

protected:
  WndMessageHolder();

private:
  static WndMessageHolder ^s_wmhInstance = nullptr;
};

}
